 --
 -- Lua for grimme tectron in LS 2011
 -- @author  usxi7sd
 -- @date  10/2012
 --
   
tectronabtank = {};

function tectronabtank.prerequisitesPresent(specializations)
    return true;
end;

function tectronabtank:load(xmlFile)
		self.threshingUVScrollPartsa = {};
        local i = 0;
        while true do
            local key = string.format("vehicle.threshingUVScrollPartsa.threshingUVScrollPart(%d)", i);
            if not hasXMLProperty(xmlFile, key) then
                break;
            end;
            local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
            local speed = Utils.getVectorNFromString(getXMLString(xmlFile, key.."#speed"), 2);
            if node ~= nil and speed then
                table.insert(self.threshingUVScrollPartsa, {node=node, speed=speed});
            end;
           i = i +1;
       end;   
	self.visibility3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.visibility3#index"));
	setVisibility(self.visibility3, false);
	
	self.printWarningTime1 = 0;
	self.printWarningTime2 = 0;	
end;

function tectronabtank:delete()
end;
function tectronabtank:readStream(streamId, connection)
end;
function tectronabtank:writeStream(streamId, connection)
end;
function tectronabtank:mouseEvent(posX, posY, isDown, isUp, button)
end;
function tectronabtank:keyEvent(unicode, sym, modifier, isDown)
end;

function tectronabtank:update(dt)
		if self.pipeParticleActivated then
				for _, part in pairs(self.threshingUVScrollPartsa) do
					setShaderParameter(part.node, "uvScrollSpeed", part.speed[1], part.speed[2], 0, 0, false);
				end;
				else
				for _, part in pairs(self.threshingUVScrollPartsa) do
					setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
				end;		
		end;
		if self.pipeParticleActivated then
			setVisibility(self.visibility3, true);  -- Texture potatoBeltExport
			else
			setVisibility(self.visibility3, false);
		end;
		
		if self:getIsActive() then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) and self.grainTankFillLevel > 0 then
				self.printWarningTime1 = self.time + 2000;
				self:setFoldDirection(0);
			end;		
			if InputBinding.hasEvent(InputBinding.ACTIVATE_THRESHING) and self.foldMoveDirection > 0.1 then
				self.printWarningTime2 = self.time + 2000;
				self:setIsThreshing(false);
			end;
		end;		
end;

function tectronabtank:updateTick(dt)	
end;

function tectronabtank:draw()
	if self:getIsActive() then	    
		if self.targetPipeState == 2 then
			g_currentMission:addHelpButtonText(g_i18n:getText("abtank_deaktivate"), InputBinding.IMPLEMENT_EXTRA);
		   else
			g_currentMission:addHelpButtonText(g_i18n:getText("abtank_aktivate"), InputBinding.IMPLEMENT_EXTRA);
		end;
		if self.printWarningTime1 > self.time then
			g_currentMission:addWarning(g_i18n:getText("fold_Error"), 0.018, 0.030);
		end;
		if self.printWarningTime2 > self.time then
			g_currentMission:addWarning(g_i18n:getText("thre_Error"), 0.018, 0.030);
		end;
	end;
end;

function tectronabtank:onStartReel()
       self.reelStarted = true;   
       for _, part in pairs(self.threshingUVScrollPartsa) do
           setShaderParameter(part.node, "uvScrollSpeed", part.speed[1], part.speed[2], 0, 0, false);
       end;
end;

function tectronabtank:onStopReel()
       self.reelStarted = false;
       Utils.setEmittingState(self.threshingParticleSystems, false);
       self.speedViolationTimer = self.speedViolationMaxTime;
   
       for _, part in pairs(self.threshingUVScrollPartsa) do
           setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
       end;
 end;

function tectronabtank:onDeactivate()
end;

function tectronabtank:onStartTip(currentTipTrigger, noEventSend)
end;

function tectronabtank:onEndTip(noEventSend)
end;

function tectronabtank:setIsTurnedOn(turnedOn, noEventSend)
end;